/* LES TOURS DE HANOI */
/*  This soft choose the number of disks by command line
  and ask you the animation speed . */

DOMAINS
  TEMPS, LIGNE, COL, NB = INTEGER
database
  dlay(TEMPS)

PREDICATES
  hanoi( NB )
  dpl( NB, NB, LIGNE, LIGNE, LIGNE, COL, COL, COL )
  inform(  NB, NB, LIGNE, LIGNE, COL, COL )
  faitple( NB, NB, COL)
  tempo()
  effactempo
  dd(Temps)
  dpl_vert(COL,NB,LIGNE,LIGNE)
  dpl_horizon(LIGNE,NB,COL,COL)

CLAUSES

tempo :- dlay(X),!,dd(X).

dd(0):-!.
dd(N):-N1=N-1,dd(N1).

hanoi(N) :- N<=12,!,
  VB=2+6*N,VH=3+N,CV=N, CM=3*N, CH=5*N,
  STCOL=(79-6*N)/2, STLIGNE=(25-VH)/2,
  makewindow(1,10,13," Hanoi-solution ",STLIGNE,STCOL,VH,VB),
  faitple(N,N,CV),
  dpl(N,N,0,0,0,CV,CM,CH),
  cursor(0,0), write("Press a touch"),readchar(_).

hanoi(_):- write("maximum 12 disks\n").

dpl(H,1,HA,_,HC,CA,_,CH):-!, inform(H,1,HA,HC,CA,CH).
dpl(H,N,HA,HB,HC,CA,CB,CC):- N1=N-1, HA1=HA+1,
    dpl(H,N1,HA1,HC,HB,CA,CC,CB),
    inform(H,N,HA,HC,CA,CC),
    HC1=HC+1,
    dpl(H,N1,HB,HA,HC1,CB,CA,CC).

inform( H, N, H1, H2, C1, C2 ):- C11=C1-N,
    C22=C2-N,
    NN=2*N,
    H11=H-H1,
    H22=H-H2,
    dpl_vert(C11,NN,H11,1),
    dpl_horizon(1,NN,C11,C22),
    dpl_vert(C22,NN,1,H22).

faitple(_,0,_):-!.
faitple(H,N,C):- HH=H-N,
    inform(H,N,HH,HH,C,C),
    N1=N-1,
    faitple(H,N1,C).

dpl_vert(_,_,H,H):-!.
dpl_vert(COL,SIZE,H1,H2):- H1<H2,!, /* soulever */
    H11=H1+1,
    field_attr(H11,COL,SIZE,112),
    field_attr(H1,COL,SIZE,7),tempo,
    tempo, tempo,tempo, tempo,tempo,tempo,
    dpl_vert(COL,SIZE,H11,H2).
dpl_vert(COL,SIZE,H1,H2):-  H1>H2,!, /* poser */
    H11=H1-1,
    field_attr(H11,COL,SIZE,112),
    field_attr(H1,COL,SIZE,7),tempo,
    tempo,tempo,tempo,tempo,tempo,tempo,    
    dpl_vert(COL,SIZE,H11,H2).

dpl_horizon(_,_,H,H):-!.
dpl_horizon(LIGNE,SIZE,C1,C2):-  C1<C2,!, /* dplacer  droite */
    C11=C1+1,
    HH=C1+SIZE,
    field_attr(LIGNE,HH,1,112),
    field_attr(LIGNE,C1,1,7),tempo,
    tempo, tempo,tempo,tempo,tempo,tempo,
    dpl_horizon(LIGNE,SIZE,C11,C2).
dpl_horizon(LIGNE,SIZE,C1,C2):-  C1>C2,!, /* dplacer  gauche */
    C11=C1-1,
    HH=C11+SIZE,
    field_attr(LIGNE,C11,1,112),
    field_attr(LIGNE,HH,1,7),tempo,
    tempo, tempo,tempo,tempo,tempo,tempo, 
    dpl_horizon(LIGNE,SIZE,C11,C2).
effactempo :- retract(dlay(_)),fail.
effactempo.

goal
  ClearWindow,
  comline(Li),
  str_int(Li,Num),
  Concat(Li," disks ",Machaine),  
  makewindow(3,11,15,Machaine,2,3,3,55),
  write("Choose a speed from 0 (slow) to 6 (fast) :  "),
  readint(Vit),
  Vitesse=32500-Vit*5000,
  effactempo,
  assert(dlay(Vitesse)), hanoi(Num),
  RemoveWindow,
  ClearWindow,
  Removewindow,
  Clearwindow.
